/*
 * puzzle.c
 *
 *  Created on: 11 avr. 2009
 *      Author: Nahuel Fouilleul
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "utils.h"
#include "anerouge.h"
#include "puzzle.h"

byte * f = NULL;
int persist = false;

void setPersist() {
	persist = true;
}

byte getF(int id) {
	return f[id];
}

void scramble(const byte n) {
	byte i;
	srand((int) time(NULL));
	const Move * moves = getMoves();
	for (i = 0; i < n; i++) {
		exec(moves[(int) (rand() % MOVE_LENGTH)]);
	}
}

void gen(int finStates[]) {
	if (f == NULL) {
		int fsize = getSize();
		f = (byte *) malloc(fsize * sizeof(byte));
		int i = 0;
		byte p = 1, j, k;
		for (i = 0; i < fsize; i++) {
			f[i] = UNDEF;
		}
		for (i = 0; i < fsize; i++) {
			if (finStates[i] == -1)
				break;
			f[finStates[i]] = 0;
		}
		printf("0 : %d\n", i);
		int n, c;
		do {
			const Move * moves = getMoves();
			for (n = c = 0; n < fsize; n++) {
				j = f[n];
				if (j == p - 1) {
					if (!setFromInt(n)) {
						printf("Erreur  setFromInt n=%d\n", n);
						puts(getPuzzleString());
						exit(1);
					}
					for (k = 0; k < MOVE_LENGTH; k++) {
						if (exec(inv(moves[k]))) {
							c++;
							i = toInt();
							if (i == -1) {
								puts(getPuzzleString());
								puts("Fatal Error");
								exit(1);
							}
							if (f[i] == UNDEF && i > 0) {
								f[i] = p;
							}
							goBack();
						}
					}
				}
			}
			printf("%d : %d\n", p, c);
			p++;
		} while (c > 0);
	}
}

int load(int finStates[]) {
	FILE * pFile = (FILE *) fopen(getFileName(), "rb");
	if (pFile == NULL) {
		if (finStates != NULL) {
			gen(finStates);
			if (persist) {
				pFile = (FILE *) fopen(getFileName(), "wb");
				fwrite(f, sizeof(byte), getSize(), pFile);
				fclose(pFile);
			}
		} else {
			return 0;
		}
	} else {
		int size = getSize();
		f = (byte *) malloc(size * sizeof(byte));
		fread(f, sizeof(byte), size, pFile);
		fclose(pFile);
	}
	return 1;
}

char * solveOne(int print) {
	static char sol[SOL_BUF_SIZE];
	int count = 0;
	int i = toInt(), noSol = 1, j;
	const Move * moves = getMoves();
	strcat(sol, "( ");
	while (f[i] > 0) {
		for (j = 0; j < MOVE_LENGTH; j++) {
			if (exec(moves[j])) {
				if (f[i] == f[toInt()] + 1) {
					strcat(sol, getMoveString(moves[j]));
					strcat(sol, MSEP);
					if (count++ > 10) {
						count = 0;
						strcat(sol, ") \n( ");
					}
					i = toInt();
					noSol = 0;
					if (print) {
						puts(getPuzzleString());
					}
					break;
				}
				goBack();
			}
		}
		if (noSol)
			break;
		noSol = 1;
	}
	strcat(sol, ") ");
	return sol;
}

