/*
 * utils.c
 *
 *  Created on: 11 avr. 2009
 *      Author: Nahuel Fouilleul
 */

#include "utils.h"

int BINOMIAL[15][8];

int binomial(byte i, byte j) {
	if (j < 1 || j >= i)
		return 1;
	if (i < 15 && j < 8 && BINOMIAL[i][j] != 0) {
		return BINOMIAL[i][j];
	}
	int a = i, n = i, b = j, d = j;
	if (j > i << 1) {
		b = d = j = (byte)(i - j);
	}
	while (j > 2) {
		n *= --i;
		d *= --j;
	}
	if (i < 14) {
		return BINOMIAL[a][b] = (j == 1) ? n / d : n * --i / d;
	}
	return (j == 1) ? n / d : n * --i / d;
}

int btoi(byte i, byte j, byte offset, byte t[]) {
	int r = 0, s, k;
	if (j == 0)
		return 0;
	byte length = (byte)(offset + j);
	for (k = offset; k < length; k++) {
		i--;
		j--;
		s = t[k];
		if (j == 0) {
			r += s;
			break;
		}
		while (s-- > 0) {
			r += binomial(i--, j);
		}
	}
	return r;
}

byte* itob(byte i, byte j, int id, byte offset, byte b[]) {
	if (j == 0)
		return b;
	i--;
	byte length = (byte)(offset + j);
	int r = 0, u, t;
	for (t = offset; t < length; t++) {
		u = b[t] = 0;
		j--;
		while ((r += u = binomial(i, j)) <= id) {
			b[t]++;
			i--;
		}
		i--;
		r -= u;
	}
	return b;
}

byte code(byte r, byte o, byte n) {
	return (byte)((r / o) * n + r % o);
}

byte codeij(byte i, byte j, byte n) {
	return (byte)(i * n + j);
}

byte codei(byte r, byte n) {
	return (byte)(r / n);
}

byte codej(byte r, byte n) {
	return (byte)(r % n);
}

